/*
 * Copyright © 2009 Perseus Project - Tufts University <http://www.perseus.tufts.edu>
 *
 * This file is part of UniCollatorPerseus.
 *
 * OcroPerseus is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * OcroPerseus is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with OcroPerseus.  If not, see <http://www.gnu.org/licenses/>.
 */

/* Evaluate if each word is Latin (true) or Greek (false)
 * and  transforms Greek chars into Latin chars within Latin words
 * and Latin chars into Greek chars within Greek words
 *
 * Usage: eu.himeros.ocrtrainer.AdjustOcr ocr.txt adjusted-output.txt greekTranscoder.txt latinTranscoder.txt
 * Example: guli1.0-oc guli1.0-oc-adj ocr2grk.txt ocr2lat.txt
*/

package eu.himeros.script

import eu.himeros.transcoder.Transcoder

boolean testLatin(String str){
    double len=str.length()
    int greekChars=0;
    for(int i=0;i<str.length();i++){
        if(str.charAt(i)>256){
            greekChars++
        }
        if(greekChars>=(len/2)) return false
    }
    return true
}
def w=new File(args[1]+".txt").newWriter()
def transGreek=new Transcoder(args[2])
def transLatin=new Transcoder(args[3])
def String s=""
new File(args[0]+".txt").eachLine{l->
    l=l.trim()
    l=l.replaceAll(" +"," ")
    String[] items=l.split(" ")
    items.each{item->
        if(testLatin(item)){
            item=transLatin.parse(" "+item+" ").trim()
        }else{
            item=transGreek.parse(" "+item+" ").trim()
            item=item.replaceAll("([^.,:;]*)[.,:;·]([\u0370-\u03FF\u1F00-\u1FFF]+)","\$1\$2")
        }
        s+=item+" "
    }
    w.writeLine(s.trim())
    s=""
}
w.close()
