/*
 * Copyright © 2009 Perseus Project - Tufts University <http://www.perseus.tufts.edu>
 *
 * This file is part of UniCollatorPerseus.
 *
 * OcroPerseus is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * OcroPerseus is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with OcroPerseus.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package eu.himeros.script

import eu.himeros.alignment.AnchorFinder
import eu.himeros.alignment.ErrorPatternMaker
import eu.himeros.alignment.StringAligner
import eu.himeros.alignment.UpperCaseSimEvaluator
engines=["ab-ca-","an-ca-","oc-ca-"]
//engines=["ax-"]
edit="kaibel"
nums=["1","2","3","4","5"]
nums.each{n->
    engines.each{engine->
        int len=2;
        String[] fileNames=new String[len];
        String[] texts=new String[len];
        fileNames[0]=engine+"trn-"+edit+n+".0.txt";
        fileNames[1]="gt-trn-"+edit+n+".0.txt";
        w= new File(engine+"err-"+edit+n+".0.txt").newWriter()
        epm=new ErrorPatternMaker()
        epm.setGapTag('\u00B0')
        alg=new StringAligner(new UpperCaseSimEvaluator()) // TODO ADD THE SimEvaluator!!!
        for(int i=0;i<len;i++){
            r=new File(fileNames[i]);
            r.eachLine{line ->
                texts[i]+=line+"\u00B6"; //substitute CR with the paragraph sign
            }
        }
        Vector[] v=new Vector[len]
        String[] chunks=new String[len]
        int[] beg=new int[len+1]
        int[] end=new int[len+1]
        for(int i=0;i<len;i++){
            beg[i]=0
            v[i]=new Vector()
            chunks[i]=""
        }
        AnchorFinder af=new AnchorFinder(fileNames,"[^\\u0370-\\u03FF\\u1F00-\\u1FFF\\u2019]")
        anchors=af.findAnchors()
        for(int j=0;j<anchors[0].size();j++){
            for(int i in 0..len-1){
                end[i]=anchors[i+1].get(j)
                while(end[i]<texts[i].length()&&(c=texts[i].charAt(end[i]))!=' '&&c!='\u00B6'){
                    end[i]++
                }
                end[i]++
            }
            try{
                if (end[0]>beg[0] && end[1]>beg[1]){
                    algs=alg.align(texts[0].substring(beg[0],end[0]),texts[1].substring(beg[1],end[1]))
                    epm.add(algs[0],algs[1])
                }
            }catch(Exception ex){}
            for(i in 0..len) beg[i]=end[i]
        }
        epm.makeErrorSet()
        epm.writeErrorPatterns(w)
        w.close()
    }
}