/*
 * Copyright © 2009 Perseus Project - Tufts University <http://www.perseus.tufts.edu>
 *
 * This file is part of UniCollatorPerseus.
 *
 * OcroPerseus is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * OcroPerseus is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with OcroPerseus.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package eu.himeros.script

import eu.himeros.alignment.AnchorFinder
import eu.himeros.alignment.MultiAligner

MultiAligner ma=new MultiAligner()
String[] fileNames=new String[3]
String[] editions=new String[3]
//String n="1"
System.setProperty("eu.himeros.alignment.evaluator","/apps/ocr/resources/transcoders/lowercase2uppercase.txt")
String editor="kaibel"
nums=["1","2","3","4","5"]
nums.each{n->
fileNames[0]="oc-ca-adj-"+editor+n+".0.txt"
fileNames[1]="ab-ca-adj-"+editor+n+".0.txt"
fileNames[2]="an-ca-adj-"+editor+n+".0.txt"
resFile="al-ca-mlt-"+editor+n+".0.txt"
alignedFile="al-ca-"+editor+n+".0.txt"
ma.addErrorPatternFile("oc-err-"+editor+n+".0.txt")
ma.addErrorPatternFile("ab-err-"+editor+n+".0.txt")
ma.addErrorPatternFile("an-err-"+editor+n+".0.txt")
for(int i=0;i<3;i++){
    editions[i]="";
    r=new File(fileNames[i]);
    r.eachLine{line ->
        editions[i]+=line+"\u00B6"
    }
}
Vector[] v=new Vector[3]
String[] chunks=new String[3]
int[] beg=new int[3]
int[] end=new int[3]
for(int i=0;i<3;i++){
    beg[i]=0
    v[i]=new Vector()
    chunks[i]=""
}
//AnchorFinder af=new AnchorFinder(fileNames,"[^\\u0370-\\u03FF\\u1F00-\\u1FFF\\u2019]")
AnchorFinder af=new AnchorFinder(fileNames,"[\\u0370-\\u03FF\\u1F00-\\u1FFF\\u2019]")
anchors=af.findAnchors()
for(int j=0;j<anchors[0].size();j++){
    for(i in 0..2){
        end[i]=anchors[i+1].get(j)
        while(end[i]<editions[i].length()&&(c=editions[i].charAt(end[i]))!=' '&&c!='\u00B6'){
            end[i]++
        }
        end[i]++
    }
    //for(i in 0..2) println(editions[i].substring(beg[i],end[i]))
    for(i in 0..2) v[i].add(editions[i].substring(beg[i],end[i]))
    for(i in 0..2) beg[i]=end[i]
}
ma.exec(v, resFile, alignedFile);
}