/*
 * Copyright © 2009 Perseus Project - Tufts University <http://www.perseus.tufts.edu>
 *
 * This file is part of UniCollatorPerseus.
 *
 * OcroPerseus is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * OcroPerseus is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with OcroPerseus.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Given a text file (without extension), write in the output file a table with:<br/>
 * 1. prog. number
 * 2. frequency
 * 3. word
 *
 */

package eu.himeros.script

def r=new File(args[0]+".txt");
def w=new File(args[0]+".csv").newWriter();
def i=0
def s=""
wordV=new Vector()
freqHt=new Hashtable()
r.eachLine{line->
    if(line.charAt(line.length()-1)=='-') 
         s+=line.substring(0,line.length()-1)
    else
         s+=line+" "
}
words=s.split(" ")
words?.each{word->
     if(word!=null&&word!=""){
         wordV.add(word)
         freq=freqHt.get(word)
         if(freq==null){
              freqHt.put(word,new Integer(1))
         }else{
              freqHt.put(word,new Integer(freq.intValue()+1))
         }
     }
}
wordV.each{wd->
   i++
   w.writeLine(""+i+"\t"+freqHt.get(wd).toString()+"\t"+wd)
}
w.close()
